//***************************************************************************
// Ces applets viennent en complment du livre :
//
//  		VIE ARTIFICIELLE
//      O la biologie rencontre l'informatique
//		Illustr en Java
//            Jean-Philippe Rennard
//           	  Vuibert 2002
//===========================================================================
//  Algorithme Gntique : Problme du Voyageur de Commerce  (Vuibert)
//    v:0.1 10/09/2002
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package pvcag;

import java.awt.*;
import java.awt.event.*;
import vabase.*;

/** Interface utilisateur de l'algorithme gntique */
public class pvcUI extends Cui {
  /** L'algorithme gntique */
  Cag ag;
  /** Paramtres */
  int nbVillesAg=Cag.NB_VILLES;
  int popAg=Cag.POP;
  float mutAg=Cag.MUTATION;
  int echelAg=Cag.SCALELINEAR;

  /** lments d'interface */
  BorderLayout borderLayout1 = new BorderLayout();
  Panel panelVue = new Panel();
  GridLayout gridLayout1 = new GridLayout();
  Panel panel2 = new Panel();
  Button btnGo = new Button();
  Button btnPas = new Button();
  GridLayout gridLayout2 = new GridLayout();
  Panel panel3 = new Panel();
  Panel panel4 = new Panel();
  Button btnNouveau = new Button();
  GridLayout gridLayout3 = new GridLayout();
  Panel panel5 = new Panel();
  GridLayout gridLayout4 = new GridLayout();
  Panel panel6 = new Panel();
  GridLayout gridLayout5 = new GridLayout();
  Label label1 = new Label();
  Label label2 = new Label();
  Label lbGeneration = new Label();
  Label lbSigma = new Label();
  GridLayout gridLayout6 = new GridLayout();
  Label label5 = new Label();
  Label label6 = new Label();
  Label lbMeilleur = new Label();
  Label lbPire = new Label();
  Panel panel7 = new Panel();
  Choice chPop = new Choice();
  Choice chEch = new Choice();
  GridLayout gridLayout7 = new GridLayout();
  Panel panel8 = new Panel();
  Choice chNbVilles = new Choice();
  Choice chCross = new Choice();
  Panel panel9 = new Panel();
  GridLayout gridLayout8 = new GridLayout();
  Panel panel10 = new Panel();
  GridLayout gridLayout9 = new GridLayout();
  Label label9 = new Label();
  Label label10 = new Label();
  Label label11 = new Label();
  Label label12 = new Label();
  Label label13 = new Label();
  Label label14 = new Label();
  TextField txtMutation = new TextField();
  GridLayout gridLayout10 = new GridLayout();
  Panel panel11 = new Panel();
  GridLayout gridLayout11 = new GridLayout();
  Checkbox cbMode = new Checkbox();
  Panel panel12 = new Panel();
  Panel panel13 = new Panel();
  Panel panel14 = new Panel();
  GridLayout gridLayout12 = new GridLayout();
  Checkbox cbAffParcours = new Checkbox();

  /** Constructeur */
  public pvcUI(pvcLaunch am) {
    super((Claunch)am);
    ag=new Cag(this, nbVillesAg, popAg, mutAg);
    process=(Cprocess)ag;
    try  {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /* Initialisation */
  private void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    panelVue.setBackground(Color.red);
    panelVue.setLayout(gridLayout1);
    btnGo.setLabel("Go");
    btnGo.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnGo_actionPerformed(e);
      }
    });
    btnPas.setLabel("Pas  Pas");
    btnPas.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnPas_actionPerformed(e);
      }
    });
    panel2.setLayout(gridLayout2);
    this.addComponentListener(new java.awt.event.ComponentAdapter() {
      public void componentResized(ComponentEvent e) {
        this_componentResized(e);
      }
    });
    gridLayout2.setColumns(4);
    btnNouveau.setLabel("Nouveau");
    btnNouveau.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnNouveau_actionPerformed(e);
      }
    });
    panel4.setLayout(gridLayout3);
    panel3.setLayout(gridLayout4);
    panel6.setLayout(gridLayout5);
    gridLayout5.setRows(2);
    gridLayout5.setColumns(2);
    label1.setText("Gn.");
    label2.setText("Sigma");
    lbGeneration.setAlignment(2);
    lbGeneration.setText("0");
    lbSigma.setAlignment(2);
    lbSigma.setText("0");
    panel5.setLayout(gridLayout6);
    gridLayout6.setRows(2);
    gridLayout6.setColumns(2);
    label5.setText("Meilleur");
    label6.setText("Pire");
    lbMeilleur.setAlignment(2);
    lbMeilleur.setText("0");
    lbPire.setAlignment(2);
    lbPire.setText("0");
    gridLayout4.setHgap(5);
    panel7.setLayout(gridLayout7);
    gridLayout7.setRows(2);
    gridLayout7.setColumns(1);
    panel9.setLayout(gridLayout8);
    gridLayout8.setColumns(7);
    gridLayout8.setHgap(5);
    panel8.setLayout(gridLayout9);
    gridLayout9.setColumns(6);
    label9.setAlignment(1);
    label9.setText("Nb. villes");
    label10.setAlignment(1);
    label10.setText("Crossover");
    label11.setAlignment(1);
    label11.setText("Population");
    label12.setAlignment(1);
    label12.setText(""); //"Mode"
    label13.setAlignment(1);
    label13.setText("Mutation");
    label14.setAlignment(1);
    label14.setText("Op. slect.");
    panel10.setLayout(gridLayout10);
    panel11.setLayout(gridLayout11);
    cbMode.setLabel("Elitisme");
    cbMode.setState(true);
    cbMode.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        cbMode_itemStateChanged(e);
      }
    });
    chNbVilles.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        chNbVilles_itemStateChanged(e);
      }
    });
    chPop.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        chPop_itemStateChanged(e);
      }
    });
    txtMutation.setText("0.05");
    txtMutation.addTextListener(new java.awt.event.TextListener() {
      public void textValueChanged(TextEvent e) {
        txtMutation_textValueChanged(e);
      }
    });
    chEch.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        chEch_itemStateChanged(e);
      }
    });
    gridLayout3.setRows(2);
    gridLayout3.setColumns(3);
    panel13.setLayout(gridLayout12);
    cbAffParcours.setLabel("Vue pire");
    cbAffParcours.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        cbAffParcours_itemStateChanged(e);
      }
    });
    chCross.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        chCross_itemStateChanged(e);
      }
    });
    this.add(panelVue, BorderLayout.CENTER);
    this.add(panel2,  BorderLayout.SOUTH);
    panel2.add(panel4, null);
    panel4.add(panel13, null);
    panel13.add(cbAffParcours, null);
    panel4.add(panel12, null);
    panel4.add(panel14, null);
    panel4.add(btnNouveau, null);
    panel4.add(btnGo, null);
    panel4.add(btnPas, null);
    panel2.add(panel3, null);
    panel3.add(panel6, null);
    panel6.add(label1, null);
    panel6.add(lbGeneration, null);
    panel6.add(label2, null);
    panel6.add(lbSigma, null);
    panel3.add(panel5, null);
    panel5.add(label5, null);
    panel5.add(lbMeilleur, null);
    panel5.add(label6, null);
    panel5.add(lbPire, null);
    this.add(panel7, BorderLayout.NORTH);
    panel7.add(panel8, null);
    panel8.add(label9, null);
    panel8.add(label11, null);
    panel8.add(label13, null);
    panel8.add(label14, null);
    panel8.add(label12, null);
    panel8.add(label10, null);
    panel7.add(panel9, null);
    panel9.add(chNbVilles, null);
    panel9.add(chPop, null);
    panel9.add(panel10, null);
    panel10.add(txtMutation, null);
    panel9.add(chEch, null);
    panel9.add(panel11, null);
    panel9.add(chCross, null);
    panel11.add(cbMode, null);
    // Elments des menus
    chNbVilles.addItem("8");
    chNbVilles.addItem("12");
    chNbVilles.addItem("20");
    chNbVilles.addItem("30");
    chNbVilles.addItem("50");
    chNbVilles.addItem("75");
    chNbVilles.addItem("127");
    chNbVilles.select(2);
    chPop.addItem("20");
    chPop.addItem("50");
    chPop.addItem("100");
    chPop.addItem("250");
    chPop.addItem("500");
    chPop.addItem("1000");
    chPop.select(2);
    chEch.addItem("Aucun");
    chEch.addItem("Linaire");
    chEch.addItem("Ranking");
    chEch.addItem("Sigma");
    chEch.select(1);
    chCross.addItem("Inversion");
    chCross.addItem("CPA");
    chCross.select(0);
    // Ajout de la vue dans un panel
    panelVue.add(ag.pvcVue,null);
  }

  /** Nouveau problme */
  void btnNouveau_actionPerformed(ActionEvent e) {
    if(ag.isRunning) {
      synchronized (ag.prThread) { ag.stop(); }
        ag.setNewPop(popAg);
        stopGo();
    }
    else {
     if(btnNouveau.getLabel()=="Valider") {
      setModifParam(false);
      btnNouveau.setLabel("Nouveau");
    }
     ag.setNewPb(nbVillesAg, popAg, mutAg);
    }
    ag.initVue();
  }
  /** Marche/arrt */
  void btnGo_actionPerformed(ActionEvent e) {
    stopGo();
  }
  /** Stop/Go */
  private void stopGo() {
    if(ag.isRunning==false) {
      btnGo.setLabel("Stop");
      btnNouveau.setLabel("Nouvelle pop.");
      setInterface(false);
      ag.lancement();
    }
    else {
      btnGo.setLabel("Go");
      btnNouveau.setLabel("Nouveau");
      ag.stop();
      setInterface(true);
    }
  }
  /** Avance pas  pas */
  void btnPas_actionPerformed(ActionEvent e) {
    ag.geneSuiv();
  }

  /** Redimensionnement de la fentre */
  void this_componentResized(ComponentEvent e) {
    redimUi();
    if(ag.generation>0) ag.affParcours();
  }
  /** Choix du mode litiste */
  void cbMode_itemStateChanged(ItemEvent e) {
    ag.setMode(cbMode.getState());
  }
  /** Choix affichage pire parcours */
  void cbAffParcours_itemStateChanged(ItemEvent e) {
    ag.setAffPire(cbAffParcours.getState());
  }

  /** Choix du nombre de villes */
  void chNbVilles_itemStateChanged(ItemEvent e) {
    int t=Integer.parseInt(chNbVilles.getSelectedItem());
    nbVillesAg=t;
    setModifParam(true);
  }
  /** Choix population */
  void chPop_itemStateChanged(ItemEvent e) {
    int t=Integer.parseInt(chPop.getSelectedItem());
    popAg=t;
    setModifParam(true);
  }
  /** Choix chelonnage */
  void chEch_itemStateChanged(ItemEvent e) {
    ag.setEchel(chEch.getSelectedIndex());
  }
  /** Choix type crossover */
  void chCross_itemStateChanged(ItemEvent e) {
    ag.setCross(chCross.getSelectedIndex());
  }

  /** Valeurs de mutation */
  void txtMutation_textValueChanged(TextEvent e) {
    try {
      mutAg=Float.parseFloat(txtMutation.getText());
    } catch (NumberFormatException r) {
      txtMutation.setText(Float.toString(Cag.MUTATION));
      mutAg=Cag.MUTATION;
    }
    if(mutAg>1 || mutAg<0) {
      txtMutation.setText(Float.toString(Cag.MUTATION));
      mutAg=Cag.MUTATION;
    }
    setModifParam(true);
  }
  /** (in)activation interface */
  public void setInterface(boolean e) {
    btnPas.setEnabled(e);
    chPop.setEnabled(e);
    chNbVilles.setEnabled(e);
    txtMutation.setEnabled(e);
  }
  /** Gestion des modifications paramtres */
  void setModifParam(boolean e) {
    setInterface(!e);
    btnGo.setEnabled(!e);
    if(e) {
      chNbVilles.setEnabled(e);
      chPop.setEnabled(e);
      txtMutation.setEnabled(e);
    }
    btnNouveau.setLabel("Valider");
  }
  /** Affichage des donnes courantes  */
  void affDonnees(double s, double m, double p) {
    affGeneration();
    String t;
    t=Double.toString(s);
    if(ag.generation%10==0)
      lbSigma.setText(t.substring(0,Math.min(10,t.length())));
    lbMeilleur.setText(Double.toString(m));
    lbPire.setText(Double.toString(p));
  }
  /** Affichage gnration */
  public void affGeneration() {
    lbGeneration.setText(Integer.toString(ag.generation));
  }
}